#include<stdio.h>
#define SIZE 10

// This program sorts an array of integers using the QuickSort algorithm.

int choosePivot(int start_index,int end_index)
{
	return (end_index);
}

void swap(int *x, int *y)
// This function swaps two variables
{
	int temp=*x;
	*x=*y;
	*y=temp;
}

void printList(int list[], int size)
// This function prints the array list
{
	int i;
	for (i=0;i<size;i++)
	{
		printf ("%d ",list[i]);
	}
	printf ("\n");
}

int partition (int list[], int start_index, int end_index)
// This function partitions the list into two sublists, according to the pivot
{
	int i,j;
	int pivot_index=choosePivot(start_index,end_index);
	int pivot_value=list[pivot_index];
	// We now move the pivot to the start.
	swap(&list[start_index],&list[pivot_index]);
	i=start_index+1;
	j=end_index;
	while (i<=j)
	{
		while ((i<=end_index) &&(list[i]<=pivot_value))
			i++;
		while ((j>=start_index) && (list[j]>pivot_value))
			j--;
		if (i<j)
			swap(&list[i],&list[j]);
	}
	swap(&list[start_index],&list[j]);
	pivot_index=j;
	return pivot_index;
}

void quickSort (int list[], int start_index, int end_index)
// This function implements the quickSort algorithm
{
	int pivot_index;
	if (start_index<end_index) // more than one element in list
	{
		// We now partition the list into two sublists:
		pivot_index=partition(list, start_index, end_index);

		// Performing Quick Sort on both sublists:
		quickSort(list,start_index,pivot_index-1);
		quickSort(list,pivot_index+1,end_index);
	}
	
}


int main()
{
	int array[SIZE]={0};
	int i;
	printf ("Please insert the numbers:\n"); 
	for (i=0;i<SIZE;i++)
	{
		scanf ("%d",&array[i]);
	}
	printf ("The numbers before:\n");
	printList(array,SIZE);
	quickSort (array,0,SIZE-1);
	printf ("The sorted numbers:\n");
	printList(array,SIZE);
	return 0;
}