#include<stdio.h>
#include<string.h>
#define SIZE 51
#define NUM 10

// This program sorts a list of strings using the QuickSort algorithm.

void readString(char string[],int size)
{
	int i=0;
	char c;
	scanf("%c",&c);
	while ((c!='\n')&&(i<size))
	{
		string[i]=c;
		i++;
		scanf("%c",&c);
	}
	string[i]='\0';
}
int choosePivot(int start_index,int end_index)
{
	return (end_index);
}



void swap(char x[], char y[])
// This function swaps two variables (strings)
{
	int i=0;
	char temp[SIZE]="";
	strcpy(temp,x);
	strcpy(x,y);
	strcpy(y,temp);
}

void printList(char list[][SIZE], int size)
// This function prints the array list
{
	int i;
	for (i=0;i<size;i++)
	{
		printf ("%s\n",list[i]);
	}
}

int partition (char list[][SIZE], int start_index, int end_index)
// This function partitions the list into two sublists, according to the pivot
// After this function, the pivot is in its place.
{
	int i,j;
	int pivot_index=choosePivot(start_index,end_index);
	char pivot_string[SIZE]="";
	strcpy(pivot_string,list[pivot_index]);

	// We now move the pivot to the start.
	swap(list[start_index],list[pivot_index]);

	i=start_index+1;
	j=end_index;
	while (i<=j)
	{
		while ((i<=end_index) &&(strcmp(list[i],pivot_string)<=0))
			i++;
		while ((j>=start_index) && (strcmp(list[j],pivot_string)>0))
			j--;
		if (i<j)
			swap(list[i],list[j]);
	}
	swap(list[start_index],list[j]);
	pivot_index=j;
	return pivot_index;
}

void quickSort (char list[][SIZE], int start_index, int end_index)
// This function implements the Quick Sort algorithm
{
	int pivot_index;
	if (start_index<end_index) // more than one element in list
	{
		// We now partition the list into two sublists:
		pivot_index=partition(list, start_index, end_index);
		// Performing Quick Sort on both sublists:
		quickSort(list,start_index,pivot_index-1);
		quickSort(list,pivot_index+1,end_index);
	}
	
}


int main()
{
	char list[NUM][SIZE]={""};
	int i;
	printf ("Please insert the strings:\n"); 
	for (i=0;i<NUM;i++)
	{
		readString(list[i],SIZE);
	}
	printf ("The strings before sorting:\n");
	printList(list,NUM);
	quickSort (list,0,NUM-1);
	printf ("The sorted strings:\n");
	printList(list,NUM);
	return 0;
}